{
    By: Kwabena W. Agyeman - 9/27/2013
}

CON
    _clkfreq = 80_000_000
    _clkmode = xtal1 + pll16x
    
    CLK_FREQ = ((_clkmode - xtal1) >> 6) * 5_000_000 
    MS_001   = CLK_FREQ / 1_000                                   ' ticks in 1ms
    US_001   = CLK_FREQ / 1_000_000  
    rx = 31
    tx = 30
    lPin = 26
    rPin = 27
    doPin = 22
    clkPin = 23
    diPin = 24
    csPin = 25
    wpPin = -1
    cdPin = -1
    SDA  = 29                                                     ' eeprom / i2c
    SCL  = 28
    LEDS = 15                                                   ' LED tx pin
    RANGE         = 255            'Range is 0 to RANGE.
    SAMPLES       = 200            'Number of samples to pick: 1 to RANGE + 1
    maxbright=60
    STRIP_LEN = 8  
    MIC_ADC_OUT     = 21          'Output (feedback) for microphone sigma-delta ADC.
    MIC_ADC_IN      = 20          'Input for microphone sigma-delta ADC. 
    playled = 12
    senseled=13                             '
  '             RR GG BB
  BLACK      = $00_00_00
  RED        = $FF_00_00
  GREEN      = $00_FF_00
  BLUE       = $00_33_66
  WHITE      = $FF_FF_FF
  CYAN       = $00_FF_FF
  MAGENTA    = $FF_00_FF
  YELLOW     = $FF_FF_00
  CHARTREUSE = $7F_FF_00
  ORANGE     = $FF_60_00
  AQUAMARINE = $7F_FF_D4
  PINK       = $FF_5F_5F
  TURQUOISE  = $3F_E0_C0
  REALWHITE  = $C8_FF_FF
  INDIGO     = $3F_00_7F
  VIOLET     = $BF_7F_BF
  MAROON     = $32_00_10
  BROWN      = $0E_06_00
  CRIMSON    = $DC_28_3C
  PURPLE     = $8C_00_FF 
  GOLD       = $FF_CC_00       
var
    byte song,isplaying
    byte numbers[RANGE + 1]
    byte rannum
    long rgbl,micVal
    byte gc
    long rgbls[strip_len] 
    byte stack[500],stackb[500] 
obj
  strip : "jm_ws2812_ss"  'cog                                      ' single-shot WS2812 LED driver
  'ser: "FullDuplexSerial.spin"'cog
  wav: "V3-WAV_DACEngine.spin" '4cogs

PUB main| pos,z
    dira[playled..senseled]~~
    outa[senseled]:=0
    outa[playled]:=1
    song:=8
    ''ser.Start(rx, tx, 0, 19200)
    pause(1000)
    if(wav.begin(lPin, rPin, doPin, clkPin, diPin, csPin, wpPin, cdPin))
        'ser.Str(string("Start: Success", 10))
    else
        'ser.Str(string("Start: Failure", 10))
    start_mic_env    
    wav.setRightVolume (2) '' -8 to 7 (negative lowers the volume)
    wav.setLeftVolume (2) '' -8 to 7 (negative lowers the volume)    
    strip.start_b(STRIP_LEN)                                     ' start led driver
    strip.off(-1)                                                 
    strip.execute(LEDS, -1, -1)
    cognew(checksensorRepeat,@stackB) 
     
    repeat
       repeat 
           pause(250)
           !outa[senseled] 
       until micVal>75
       playit

                
pub checksensor
     micVal:=Envelope>>8
     case micVal
        0..13:color_wipe(0,0, 0)
        14..75:color_wipe(BLUE, micVal, 0)
        76..255:color_wipe(GOLD, micVal/2, 0)   
        
pub checksensorRepeat
   repeat  
     micVal:=Envelope>>8
     case micVal
        0..13:color_wipe(0,0, 0)
        14..90:color_wipe(BLUE, micVal, 0)
        91..255:color_wipe(GOLD, micVal/2, 0)  

pub playit
    outa[playled]:=0
    case song
      0:result := \wav.play(string("wvufs.wav"),@isplaying)
      1:result := \wav.play(string("croads2.wav"),@isplaying)
      2:result := \wav.play(string("fsintro.wav"),@isplaying)
      3:result := \wav.play(string("croads4.wav"),@isplaying)
      4:result := \wav.play(string("wvuam.wav"),@isplaying)
      5:result := \wav.play(string("croads3.wav"),@isplaying)
      6:result := \wav.play(string("simple.wav"),@isplaying) 
      7:result := \wav.play(string("croads1.wav"),@isplaying) 
      8:result := \wav.play(string("gn.wav"),@isplaying)      
    pause(30000)
    outa[playled]:=1
    if song==8
       song:=0
    else
       song++ 
     
    
            
pub color_wipe(rgb, mV, ms) | ch
  repeat ch from 0 to strip.num_pixels-1 
    strip.setx(ch, rgb, mV, -1)
    'strip.set(ch, rgb, -1)
    strip.execute(LEDS, -1, -1)
    pause(ms)
    
PUB start_mic_env
  '' Start microphone Envelope detector.
  ''xample: s2.start_mic_env 'Start the microphone Envelope detector.
  ifnot (Mic_cog)
    mic_dt := clkfreq / 8000
    mic_cyc := 8000 / 20
    return (Mic_cog := cognew(@env_det, @Envelope) + 1) > 0
    
    
pub pause(ms) | t
'' Delay program in milliseconds
  if (ms < 1)                                                   ' delay must be > 0
    return
  else
    t := cnt - 1776                                             ' sync with system counter
    repeat ms                                                   ' run delay
      waitcnt(t += MS_001)
        
DAT

''-------[ Microphone ]-----------------------------------------------

              org       0

env_det       mov       ctra,mic_ctra0          'Set up ctra for sigma-delta ADC.
              mov       dira,mic_dira0
              mov       frqa,#1
              mov       mic_bias,mic_dt         'Guess at adc bias level:
              shr       mic_bias,#1             '  dt / 2.
              mov       mic_time,cnt            'Initialize interval timer.
              add       mic_time,mic_dt
              mov       mic_pamp,phsa           'Save baseline value.

env_lp        mov       mic_acc,#0              'Initialize the Envelope for this major cycle.
              mov       mic_cnt,mic_cyc         'Initialize the sample count for this cycle.

mic_lp        call      #mic_samp               'Sample the mic input.
              addabs    mic_acc,mic_amp         'Add its abs value to Envelope.
              djnz      mic_cnt,#mic_lp         'Back for another sample.

              wrlong    mic_acc,par             'Write the Envelope value to hub.
              jmp       #env_lp                 'Back for another cycle.
Envelope      long      0
'-------[ Microphone sample routine ]------------------------------------------

'    Read the ADC (microphone) input.

mic_samp      waitcnt   mic_time,mic_dt         'Wait for adc value to be accumulated.
              mov       mic_amp,phsa            'Read it.
              sub       mic_amp,mic_pamp        'Subtract the previous reading.
              add       mic_pamp,mic_amp        'pamp := pamp + amp - pamp == pamp
              sub       mic_amp,mic_bias        'Subtract the DC bias.
              shl       mic_bias,#4             'Compute running average of bias.
              add       mic_bias,mic_amp
              shr       mic_bias,#4
mic_samp_ret  ret               

mic_cyc       long      0-0
mic_dt        long      0-0
mic_dira0     long      1 << MIC_ADC_OUT
mic_ctra0     long      %01001 << 26 | MIC_ADC_OUT << 9 | MIC_ADC_IN 

mic_bias      res       1
mic_acc       res       1
mic_cnt       res       1
mic_time      res       1
mic_pamp      res       1
mic_amp       res       1

              fit
Mic_cog       byte      0